# COUNTELEMENTS: returns a list with the first indice of the list referring
#                to the number of elements in the string input and the rest
#                of the indices in the returned list containing elements
#                of the string (where each element is seperated by space that
#                is not enclosed within brackets or braces)
# 
# Heinz Kuo, 08/06/2002
# schwmmrl@uclink4.berkeley.edu
#
# routine to be used in ISSRCDPROC.TCL 
# example:   countlements string
proc countelements {lineend} {
   set numelements 0           ;# counts number of elements that has been saved
   set prev_open 0             ;# history of open brackets since last saved element
   set prev_close 0            ;# history of close brackets since last saved element
   set prev_string ""          ;# stores unsaved element because it is not finished
   set line_elements [list]    ;# initialize variable storing each element in a line

   set brokenline [split $lineend]

   foreach thegoods $brokenline {
      if {![expr [string match " " $thegoods] || \
                 [string match  "" $thegoods] ]  } {
         set  temp_open [expr [llength [split $thegoods "\["] ] - 1]
         set temp_close [expr [llength [split $thegoods "\]"] ] - 1]

         set  prev_open [expr  $prev_open +  $temp_open]
         set prev_close [expr $prev_close + $temp_close]

         if {[expr $prev_open - $prev_close] == 0} {
            if {$prev_open != 0} {append prev_string " "}
            append prev_string $thegoods

            lappend line_elements $prev_string
            incr numelements

            set prev_open 0;   set prev_close 0;   set prev_string ""
         } else {
            if {$prev_open != $temp_open} {append prev_string " "}
            append prev_string $thegoods
         }
      }
   }

   set line_elements [linsert $line_elements 0 $numelements]
   return $line_elements
}
