# FIXLABEL: returns a string with variables renamed by appending the prefix

#           procnum to it

# tricky because need to catch all commands that need not "$" to refer to variable

# 

#

# Heinz Kuo, 08/06/02

# schwmmrl@uclink4.berkeley.edu

#

# routine to be used in PARSELY.TCL 

# example:   fixlabel string procnum

proc fixlabel {lineend procnum} {

   source "parsely/isstop.tcl"

   source "parsely/spacesize.tcl"

   source "parsely/isgeneric.tcl"

   source "parsely/isfrontier.tcl"

   source "parsely/makemapcmd.tcl"



   if {[isfrontier $lineend "pound"] || [isstop $lineend] || [isfrontier $lineend "else"]} {

      # skipt comment lines, closing curlies, and else

   } elseif {[isfrontier $lineend "set"] } {

      # Prepare variable name when set

      set key "set";  set value "set"

      set spacer [string repeat " " [spacesize $lineend "set"]]



      append key $spacer;   append value $spacer;   append value $procnum

      set lineend [makemapcmd $key $value $lineend]

      set lineend [eval $lineend]



      # Prepare other variables

      set key "\$";   set value "\$";   append value $procnum

      set lineend [makemapcmd $key $value $lineend]

      set lineend [eval $lineend]

   } elseif {[isfrontier $lineend "while"]} {

      set brokenline [split $lineend "\{\}"]

      set retlineend "while \{"



      # Prepare TEST of WHILE LOOP

      set key "\$";   set value "\$";   append value $procnum

      set lineend [lindex $brokenline 1]

      set lineend [makemapcmd $key $value $lineend]

      set lineend [eval $lineend]

      append retlineend $lineend

      append retlineend "\} \{"



      set lineend $retlineend

   } elseif {[isfrontier $lineend "for"]} {

      set brokenline [split $lineend "\{\}"]

      set retlineend "for \{"



      # Prepare START of FOR LOOP

      set key "set";  set value "set"

      set lineend [lindex $brokenline 1]

      set spacer [string repeat " " [spacesize $lineend "set"]]



      append key $spacer;   append value $spacer;   append value $procnum

      set lineend [makemapcmd $key $value $lineend]

      set lineend [eval $lineend]



      set key "\$";   set value "\$";   append value $procnum

      set lineend [makemapcmd $key $value $lineend]

      set lineend [eval $lineend]



      append retlineend $lineend

      append retlineend "\} \{"



      # Prepare TEST of FOR LOOP

      set key "\$";   set value "\$";   append value $procnum

      set lineend [lindex $brokenline 3]

      set lineend [makemapcmd $key $value $lineend]

      set lineend [eval $lineend]

      append retlineend $lineend

      append retlineend "\} \{"



      # Prepare NEXT of FOR LOOP

      set key "incr";  set value "incr"

      set lineend [lindex $brokenline 5]

      set spacer [string repeat " " [spacesize [lindex $brokenline 5] "incr"]]



      append key $spacer;   append value $spacer;   append value $procnum

      set lineend [makemapcmd $key $value $lineend]

      set lineend [eval $lineend]

      append retlineend $lineend

      append retlineend "\} \{"



      set lineend $retlineend

   } elseif {[isfrontier $lineend "elseif"]} {

      set brokenline [split $lineend "\{\}"]

      set retlineend "\} elseif \{"



      # Prepare TEST of ELSEIF LOOP

      set key "\$";   set value "\$";   append value $procnum

      set lineend [lindex $brokenline 2]

      set lineend [makemapcmd $key $value $lineend]

      set lineend [eval $lineend]

      append retlineend $lineend

      append retlineend "\} \{"



      set lineend $retlineend

   } elseif {[isfrontier $lineend "if"]} {

      set brokenline [split $lineend "\{\}"]

      set retlineend "if \{"



      # Prepare TEST of IF LOOP

      set key "\$";   set value "\$";   append value $procnum

      set lineend [lindex $brokenline 1]

      set lineend [makemapcmd $key $value $lineend]

      set lineend [eval $lineend]

      append retlineend $lineend

      append retlineend "\} \{"



      set lineend $retlineend

   } elseif {[isgeneric $lineend "lappend"]} {

      set key "lappend";  set value "lappend"

      set spacer [string repeat " " [spacesize $lineend "lappend"]]



      append key $spacer;   append value $spacer;   append value $procnum

      set lineend [makemapcmd $key $value $lineend]

      set lineend [eval $lineend]

   } elseif {[isgeneric $lineend "append"]} {

      set key "append";  set value "append"

      set spacer [string repeat " " [spacesize $lineend "append"]]



      append key $spacer;   append value $spacer;   append value $procnum

      set lineend [makemapcmd $key $value $lineend]

      set lineend [eval $lineend]

   } elseif {[isgeneric $lineend "incr"]} {

      set key "incr";  set value "incr"

      set spacer [string repeat " " [spacesize $lineend "incr"]]



      append key $spacer;   append value $spacer;   append value $procnum

      set lineend [makemapcmd $key $value $lineend]

      set lineend [eval $lineend]

   } else {

      set key "\$";   set value "\$";   append value $procnum

      set lineend [makemapcmd $key $value $lineend]

      set lineend [eval $lineend]

   }



   return $lineend

}

