# ISCASE: returns whether the input string is a case in a switch structure and the test case

#         depending on the option 

#         option 1 - returns whether it is a case for switch or not.  1 if it is, 0 if not

#         option 2 - returns the first 

# 

# Heinz Kuo, 08/06/2002

# schwmmrl@uclink4.berkeley.edu

#

# routine to be used in PARSELY.TCL 

# example:   iscase string option

# 

proc iscase {lineend reopt} {

   set case [split $lineend \{]

   set testcase [lindex $case 0]



   if {$reopt==1} {

      if { [llength $case]==2 } {

         # initialize return variables

         set iscaser 1

         set alttest [lindex $case 1]

         set endlength [string length $alttest]



         for {set i 0} {$i < $endlength} {incr i} {

            set carrot [string index $alttest $i]



            if {![string match " " $carrot]} {set iscaser 0}

         }



         if {$iscaser == 1} {

            set endlength [string length $testcase]

            for {set i 0} {$i < $endlength} {incr i} {

               set carrot [string index $testcase $i]



               if {[string match "\}" $carrot]} {set iscaser 0}

            }

         }



         if {$iscaser == 1} {

            set splitwithquotes [split $testcase "\""]

            set monitor 0            



            if {[llength $splitwithquotes]==1} {

               set splitwithspace [split $testcase]

               set stretch [llength $splitwithspace]



               for {set x 0} {$x < $stretch} {incr x} {

                  set tester [lindex $splitwithspace $x]

                  if {[expr ![string match "" $tester]]} {set monitor [expr $monitor+1]}

               }



               if {$monitor != 1} {set iscaser 0}

            } else {

               for {set k 0} {$k < [llength $splitwithquotes]} {incr k} {

                  set tempor [lindex $splitwithquotes $k]

                  set istestcase 0



                  for {set x 0} {$x < [llength $tempor]} {incr x} {

                     if {![string match " " [lindex $tempor $x]] && [expr $k!=1]} {set monitor [expr $monitor+1]}

                  }

               }



               if {$monitor != 0} {set iscaser 0}

            }

         }

      } else {set iscaser 0}



      return $iscaser



   } elseif {$reopt==2} {

      set splitwithquotes [split $testcase "\""]



      if {[llength $splitwithquotes]==1} {

         set splitwithspace [split $testcase]

         set stretch [llength $splitwithspace]



         for {set x 0} {$x < $stretch} {incr x} {

            set tester [lindex $splitwithspace $x]



            if {[expr ![string match "" $tester]]} {set testcase $tester;  break}

         }

      } else {

         for {set k 0} {$k < [llength $splitwithquotes]} {incr k} {

            set tempor [lindex $splitwithquotes $k]

            set istestcase 0



            for {set x 0} {$x < [llength $tempor]} {incr x} {

               if { ![string match " " [lindex $tempor $x]] } {set istestcase 1;  break}

            }



            if {$istestcase} {set testcase [lindex $splitwithquotes $k];  break}

         }

      }



      return $testcase

   }

}

