# ISGENERIC: returns whether the input string is a line beginning with the option
# 
#
# Heinz Kuo, 08/06/02
# schwmmrl@uclink4.berkeley.edu
#
# routine to be used in PARSELY.TCL 
# example:   isgeneric string "incr"
# 
proc isgeneric {lineend loopt} {
   # Make input all lower case
   set loopt [string tolower $loopt]
   set lineend [string tolower $lineend]

   # Initialize Return Variables
   set isGood 1
   set firstappearance [string first $loopt $lineend]

   if {$firstappearance != -1} {
      for {set k 0} {$k < $firstappearance} {incr k} {
         set carrot [string index $lineend $k]
         if {![string match " " $carrot] || \
             ![string match "" $carrot]} {set isGood 0;  break}
      }

      set brokenline [split $lineend];   set hasindptset 0

      foreach carrot $brokenline {
         if {[string match "set" $carrot]} {incr hasindptset; break}
      }

      if {$hasindptset < 1} {set isGood 0}
   } else {set isGood 0}

   return $isGood
}
