# ISSRCDPROC: evaluates a string to see if words in procnamelist (with corresponding

#             information in procsizelist) appear in the string.  Returns depending on option:

#    opt 1:= returns whether the input string is sourced file or not (0 or 1)

#    opt 2:= returns in list form the components of the line and the index where proc appeared

#    opt 3:= returns index of procnamelist that appears in the input string

# 

# Heinz Kuo, 08/06/02

# schwmmrl@uclink4.berkeley.edu

#

# routine to be used in PARSELY.TCL 

# example:   issrcdproc string procnamelist procsizelist opt

proc issrcdproc {lineend procnamelist procsizelist opt} {

   source "parsely/countelements.tcl"

   set issrcdprocer 0

   set k -1



   foreach thetest $procnamelist {

      incr k;   set thetruth [string first $thetest $lineend]



      if {$thetruth != -1} {

         set linecompo [countelements $lineend]

         set wheresproc [lsearch -exact $linecompo $thetest]



         if {[expr [lindex $linecompo 0]-$wheresproc] == [lindex $procsizelist $k]} {set issrcdprocer 1}

         if {[lindex $linecompo 1] != $thetest} {set issrcdprocer 0}

         if {$issrcdprocer} {break}

      }

   }



   if {$opt==1} {

      return $issrcdprocer

   } elseif {$opt==2} {

      lappend linecompo $wheresproc

      lappend linecompo $k

      return $linecompo

   } elseif {$opt==3} {

      return $k

   }

}

