# ISSTOP: returns whether the input string is an end curly braces in an if/else 

#         structure.  Returns 1 if only "}" and empty spaces exists in the input 

#         string and 0 otherwise.

# Heinz Kuo, 08/06/02

# schwmmrl@uclink4.berkeley.edu

#

# routine to be used in PARSELY.TCL 

# example:   isstop string

# 

proc isstop {lineend} {

   set endbrace \}

   set k [string first $endbrace $lineend]

   set stretch [string length $lineend]

   set reval 1



   if {$k == -1} {

      set reval 0

   } else {

      for {set i 0} {$i < $stretch} {incr i} {

         set testcase [string index $lineend $i]

         if {[expr ![string match " " $testcase]] && [expr $i != $k]} {

            set reval 0

         }

      }

   }

   return $reval

}

