# RETPROCVAR: returns a list with the new variables for proc line.
# string - string containing the begining of the procedure
# procnum - number that is added to the beginning of variables
#
# EXAMPLE:
#    %puts procline
#    proc isfrontier {lineend loopt} {
#    %retprocvar $procline 130
#    130lineend 130loopt
#    %retprocvar %procline ""
#    lineend loopt
#
# Heinz Kuo, 08/06/02
# schwmmrl@uclink4.berkeley.edu
#
# routine to be used in PARSELY.TCL 
# example:   retprocvar string procnum

proc retprocvar {lineend procnum} {
   source "parsely/isfrontier.tcl"

   if {[isfrontier $lineend "proc"]} {
      set lineend [lindex [split $lineend "\{\}"] 1]
      set lineend [split $lineend]
      set revar [list]

      foreach thegoods $lineend {
         if { ![expr [string match " " $thegoods] || \
                     [string match  "" $thegoods] ]  } {
            set newname $procnum
            append newname $thegoods
            lappend revar $newname
         }
      }
      return $revar
   }
}
