# SPACESIZE: returns a number that represents the number of blank space after 

#            the wanted string.  Returns -1 with wanted string does not appear

#            in the input string 

#

# Heinz Kuo, 08/06/02

# schwmmrl@uclink4.berkeley.edu

#

# routine to be used in PARSELY.TCL 

# example:   spacesize string wantedstring

proc spacesize {lineend wanted} {

   set wanted [string tolower $wanted]

   set lineend [string tolower $lineend]



   set strlng [string length $wanted]

   set appear [string first $wanted $lineend]



   set numspace -1



   if {$appear != -1} {

      for {set k [expr $appear + $strlng]} {$k < [string length $lineend]} {incr k} {

         incr numspace 

         if {![string match " " [string index $lineend $k]]} {break}

      }

   }



   if {$numspace<1} {return $appear} else {return $numspace}

}



