# SWTEST:  This procedure returns the test case for a switch statement
#
# Heinz Kuo, 08/06/02
# schwmmrl@uclink4.berkeley.edu 

# routine to be used in PARSELY.TCL 
# example:   swtest $line

proc swtest {line} {
   set listline [split $line]
   set listoline [split [string tolower $line]]
   set listend [llength  $listoline]

   set begind [lsearch -exact $listoline "switch"]

   if { $begind != -1 } {
      set k 0
      set listoline [lreplace $listoline 0 $begind]

      foreach value $listoline {
         incr k
         if {![expr  [string match "--" $value] ||   [string match "-glob" $value] || \
                 [string match "-exact" $value] || [string match "-regexp" $value] || \
                      [string match " " $value] ||        [string match "" $value] ]  } {
            set testind [expr $begind + $k];        break
         }
      }
   } else {
      set testind -1
   }

   set test [lindex $listline $testind]
   return $test
}
