# UTILITY:  contains procedures to make program cleaner looking

# 

# Heinz Kuo, 08/06/02

# schwmmrl@uclink4.berkeley.edu

#

#

# routine to be used in PARSELY.TCL 



# UTL_REDLIST:  Returns a list with last element eliminated

proc utl_redlist {list} {

   return [lreplace $list end end]

}



# UTL_RETLAST:  Returns the last element of a given list

proc utl_retlast {list} {

   return [lindex $list [expr [llength $list] - 1]]

}



# UTL_SEC2LAST:  Returns the second to last element of a given list

proc utl_sec2last {list} {

   return [lindex $list [expr [llength $list] - 2]]

}



# UTL_INCRLIST:  Returns a list with the last element's value increased by 1

proc utl_incrlist {list} {

   set value [lindex $list [expr [llength $list] - 1]]

   incr value

   return [lreplace $list end end $value]

}



# UTL_ISPROC:  Returns the number of procedures found in a file by using isfrontier.tcl

proc utl_isproc {filename} {

   source "parsely/isstop.tcl"

   source "parsely/isfrontier.tcl"



   set foundproc 0

   set file [open $filename "r"]



   while {![eof $file]} {   

      gets $file line

      if {[isfrontier $line "proc"]} {incr foundproc}

   }  



   close $file

   return $foundproc

}

